import java.util.*;
/**
 * This class is a simple sample of using arrays.
 */
public class Little {
    /**
     * Create a new Little object with a few arrays.  Initialize
     * the arrays to be n and 2^n.
     * @param count number of elements in the arrays
     */
    public Little(int count)    {
        myInts = new int[count];
        myDubs = new double[count];
        for (int i=0; i<myInts.length; i++) {
            myInts[i] = i;
            myDubs[i] = Math.pow(2,i);
        }
    }
    /**
     * Print the contents of the two numeric arrays.
     */
    public void printNumericArrays() {
        System.out.println("Numeric arrays");
        for (int idx=0; idx < myInts.length; idx++) {
            System.out.println(
                "idx: "+idx+
                ": "+myInts[idx]+
                ", "+myDubs[idx]);
        }
    }
    /**
     * Print the contents of the String array.
     */
    public void printStringArray() {
        System.out.println("String array");
        for (int idx=0; idx < myStrs.length; idx++) {
            System.out.println("idx: "+idx+": "+myStrs[idx]);
        }
    }
    /**
     * Sort the contents of the String array.
     */
    public void sortStringArray() {
        Arrays.sort(myStrs);
    }
    /**
     * Create a new List based on the String array.
     */
    public void createStringList() {
        yurStrs = Arrays.asList(myStrs);
    }
    /**
     * Reverse sort the List of Strings
     */
    public void reverseStringList() {
        Collections.reverse(yurStrs);
    }
    /**
     * Print the contents of the String List.
     */
    public void printStringList() {
        System.out.println("String List");
        for (int idx=0; idx < yurStrs.size(); idx++) {
            System.out.println("idx: "+idx+": "+yurStrs.get(idx));
        }
    }
    /** 
     * Run this program through its paces.
     * @param arg[0] specify the size of the
     * arrays to use.  Defaults to 5 if not given.
     */
    public static void main(String[] arg) {
        System.out.println("Number of arguments: "+arg.length);
        for (int i=0; i<arg.length; i++) {
            System.out.println("argument "+i+" is \""+arg[i]+"\"");
        }
        int size = 5;
        if (arg.length > 0) {
            try {		// try and catch will be explained later ...
                size = Integer.parseInt(arg[0]);
            }
            catch(NumberFormatException e) {
                System.out.println(e);
            }
        }
        Little obj = new Little(size);
        obj.printNumericArrays();
        obj.printStringArray();
        obj.sortStringArray();
        obj.printStringArray();
        obj.createStringList();
        obj.reverseStringList();
        obj.printStringList();
    }
        
    //--------------
    
    /** an array of ints */
    private int[] myInts;
    
    /** an array of doubles */
    private double[] myDubs;
    
    /** 
     * an array of Strings.  The size is determined by the compiler
     * when it counts the number of values provided.
     */
    private String[] myStrs = {"one","two","three"};
    /**
     * a List of Strings.  
     */
    private List yurStrs;
            
}
